unit Unitextr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Gauges, StdCtrls, ExtCtrls;

type
  TFormExportTrace = class(TForm)
    LabelTotalFiles: TLabel;
    LabelInPage: TLabel;
    GaugeTotalFiles: TGauge;
    GaugeInPage: TGauge;
    LabelInPages: TLabel;
    GaugeInPages: TGauge;
    BevelExportFile: TBevel;
    LabelExportFile1: TLabel;
    LabelExportFileIn: TLabel;
    LabelExportFileOut: TLabel;
    Image1: TImage;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormExportTrace: TFormExportTrace;

Procedure StartTraceExport;
Procedure StopTraceExport;

implementation

{$R *.DFM}

Procedure StartTraceExport;
Begin
  FormExportTrace.LabelExportFileIn.Caption:='';
  FormExportTrace.LabelExportFileOut.Caption:='';
  FormExportTrace.GaugeTotalFiles.MinValue:=0;
  FormExportTrace.GaugeTotalFiles.MaxValue:=1;
  FormExportTrace.GaugeTotalFiles.Progress:=0;
  FormExportTrace.GaugeInPages.MinValue:=0;
  FormExportTrace.GaugeInPages.MaxValue:=1;
  FormExportTrace.GaugeInPages.Progress:=0;
  FormExportTrace.GaugeInPage.MinValue:=0;
  FormExportTrace.GaugeInPage.MaxValue:=1;
  FormExportTrace.GaugeInPage.Progress:=0;
  FormExportTrace.Show;
  Application.ProcessMessages
End;

Procedure StopTraceExport;
Begin
  FormExportTrace.Hide
End;

end.
