unit Unitpsta;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, StdCtrls, ExtCtrls, AdFaxPrn,
  Unitglob;

type
  TFormPrinterStatus = class(TForm)
    BevelFaxPrintIdent: TBevel;
    LabelPrintedFilename: TLabel;
    LabelPrintedPageNr: TLabel;
    SpeedButtonBreakPrint: TSpeedButton;
    ApdFaxPrinter: TApdFaxPrinter;
    LabelPrintedFromPageNr: TLabel;
    LabelPrintedToPageNr: TLabel;
    procedure SpeedButtonBreakPrintClick(Sender: TObject);
    procedure ApdFaxPrinterFaxPrintStatus(Sender: TObject;
      StatusCode: TFaxPrintProgress);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPrinterStatus: TFormPrinterStatus;

Procedure PrintThisFax;

implementation

{$R *.DFM}

Procedure PrintThisFax;
Begin
  Try
    FormPrinterStatus.ApdFaxPrinter.FileName:=A_FaxFileName;
    If AskPrinterSetup Then
      FormPrinterStatus.ApdFaxPrinter.PrintSetup;
    AskPrinterSetup:=False;
    FormPrinterStatus.Show;
    MyResPrinting:=MyResPrintingNone;
    FormPrinterStatus.ApdFaxPrinter.Caption:='Ausdruck der Faxe';
    FormPrinterStatus.ApdFaxPrinter.PrintFax;
    FormPrinterStatus.Hide
  Finally
  End
End;

procedure TFormPrinterStatus.SpeedButtonBreakPrintClick(Sender: TObject);
begin
  FormPrinterStatus.ApdFaxPrinter.PrintAbort;
  MyResPrinting:=MyResPrintingAbort
end;

procedure TFormPrinterStatus.ApdFaxPrinterFaxPrintStatus(Sender: TObject;
  StatusCode: TFaxPrintProgress);
begin
  If MyResPrinting=MyResPrintingAbort Then
    LabelPrintedPageNr.Caption:='Abgebrochen : ('+
         IntToStr(FormPrinterStatus.ApdFaxPrinter.CurrentPrintingPage)+')'
  Else
    LabelPrintedPageNr.Caption:='Jetzt gedruckt : '+
         IntToStr(FormPrinterStatus.ApdFaxPrinter.CurrentPrintingPage);
  Application.ProcessMessages;
  FormPrinterStatus.Caption:='Faxdruck Fax '+IntToStr(A_FaxNrPrinted)+
                             ' von '+IntToStr(A_FaxSelected);
  LabelPrintedFileName.Caption:=  'Dateiname   : '+A_DumpName;
  LabelPrintedFromPageNr.Caption:='Anfangseite : '+
       IntToStr(FormPrinterStatus.ApdFaxPrinter.FirstPageToPrint);
  LabelPrintedToPageNr.Caption:=  'Endseite : '+
       IntToStr(FormPrinterStatus.ApdFaxPrinter.LastPageToPrint)
end;

end.
