unit Unitsetb;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,
  Unitglob,
  Unitcomp,
  Unittool,
  Unitstar,
  Unitstaw,
  Unitsetc,
  Unitwaid,
  Unitwaip,
  Unittesp,
  Buttons, Mask, Spin, ExtCtrls, TabNotBk, Menus, AdStatLt, ComCtrls;

type
  TFormBasicSetup = class(TForm)
    TabbedNotebookBSetup: TTabbedNotebook;
    BevelMainID: TBevel;
    LabelMainID: TLabel;
    EditMainID: TEdit;
    BevelMainNRing: TBevel;
    LabelMainNRing1: TLabel;
    LabelMainNRing2: TLabel;
    EditMainNRing: TEdit;
    SpinButtonMainNRing: TSpinButton;
    BevelReSend: TBevel;
    EditReSendNResend1: TEdit;
    EditReSendNResend2: TEdit;
    EditReSendNResend3: TEdit;
    EditReSendNResend4: TEdit;
    SpinButtonReSend1: TSpinButton;
    SpinButtonReSend2: TSpinButton;
    SpinButtonReSend3: TSpinButton;
    SpinButtonReSend4: TSpinButton;
    RadioGroupRXBPS: TRadioGroup;
    RadioGroupTXBPS: TRadioGroup;
    BevelPrinterTyp: TBevel;
    RadioButtonPrinterType0: TRadioButton;
    RadioButtonPrinterType1: TRadioButton;
    RadioButtonPrinterType2: TRadioButton;
    RadioButtonPrinterType3: TRadioButton;
    RadioButtonPrinterType4: TRadioButton;
    RadioButtonPrinterType5: TRadioButton;
    RadioButtonPrinterType6: TRadioButton;
    LabelPrinterType: TLabel;
    BevelLJDJ: TBevel;
    Bevel24pin: TBevel;
    RadioGroupPrinterLaserG: TRadioGroup;
    RadioGroupPrinterLaserS: TRadioGroup;
    LabelPrinter24Pin: TLabel;
    LabelPrinterLaserGS: TLabel;
    RadioGroupPrinter24Pin: TRadioGroup;
    ButtonPrinterTestLaserGS: TButton;
    ButtonPrinterTest24Feed: TButton;
    MenuSetup: TMainMenu;
    MenuSetupFile: TMenuItem;
    MenuSetupQuit: TMenuItem;
    MenuSetupSet: TMenuItem;
    MenuSetupMain: TMenuItem;
    MenuSetupPrinter: TMenuItem;
    MenuSetupExtras: TMenuItem;
    LabelReSend1: TLabel;
    LabelReSend2: TLabel;
    LabelReSend3: TLabel;
    LabelReSendDial1: TLabel;
    LabelReSendDial2: TLabel;
    LabelReSendDial3: TLabel;
    LabelReSendDial4: TLabel;
    LabelReSendRep1: TLabel;
    LabelReSendRep2: TLabel;
    LabelReSendRep3: TLabel;
    LabelReSendRep4: TLabel;
    LabelExtWarning1: TLabel;
    LabelExtWarning2: TLabel;
    LabelMainNRing3: TLabel;
    LabelRefax: TLabel;
    LabelMainComment1: TLabel;
    LabelMainComment2: TLabel;
    MenuFaxResend: TMenuItem;
    GroupBoxExtrasWatchSIO: TGroupBox;
    GroupBoxExtrasFaxClass: TGroupBox;
    ButtonExtrasSetClass1: TButton;
    ButtonExtrasSetClass2: TButton;
    LabelExtrasFaxClass: TLabel;
    EditExtrasFaxClass: TEdit;
    BitBtnBasicSetupWrite: TBitBtn;
    BitBtnBasicSetupBreak: TBitBtn;
    PanelReSend1: TPanel;
    CheckBoxWorkToneDial: TCheckBox;
    EditReSendDialRes1: TEdit;
    EditReSendDialRes2: TEdit;
    EditReSendDialRes3: TEdit;
    EditReSendDialRes4: TEdit;
    RadioButtonDTR: TRadioButton;
    RadioButtonRTS: TRadioButton;
    RadioButtonDTRRTS: TRadioButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    LabelRXFaxRows1: TLabel;
    LabelTXFaxRows1: TLabel;
    Edit1ATRXRow: TEdit;
    LabelRXFaxRows2: TLabel;
    LabelTXFaxRows2: TLabel;
    Edit1ATTXRow: TEdit;
    LabelRESET_TAE: TLabel;
    CheckBoxWorkEraseResend: TCheckBox;
    LabelRESET_GSM: TLabel;
    ButtonM20: TButton;
    EditATCPI: TEdit;
    LabelCPIN: TLabel;
    Bevel3: TBevel;
    Label1DUMMY: TLabel;
    Label2DUMMY: TLabel;
    Label3DUMMY: TLabel;
    CheckBoxDUMMY: TCheckBox;
    procedure SpinButtonMainNRingDownClick(Sender: TObject);
    procedure SpinButtonMainNRingUpClick(Sender: TObject);
    procedure SpinButtonReSend1DownClick(Sender: TObject);
    procedure SpinButtonReSend2DownClick(Sender: TObject);
    procedure SpinButtonReSend3DownClick(Sender: TObject);
    procedure SpinButtonReSend4DownClick(Sender: TObject);
    procedure SpinButtonReSend1UpClick(Sender: TObject);
    procedure SpinButtonReSend2UpClick(Sender: TObject);
    procedure SpinButtonReSend3UpClick(Sender: TObject);
    procedure SpinButtonReSend4UpClick(Sender: TObject);
    procedure CheckBoxExtrasAutoSerClick(Sender: TObject);
    procedure RadioGroupRXBPSClick(Sender: TObject);
    procedure RadioGroupTXBPSClick(Sender: TObject);
    procedure EditExtrasVoiceOnChange(Sender: TObject);
    procedure EditExtrasVoiceParChange(Sender: TObject);
    procedure EditExtrasRMic1Change(Sender: TObject);
    procedure EditExtrasRMic2Change(Sender: TObject);
    procedure EditExtrasRLin1Change(Sender: TObject);
    procedure EditExtrasRLin2Change(Sender: TObject);
    procedure EditExtrasTLin1Change(Sender: TObject);
    procedure EditExtrasTLin2Change(Sender: TObject);
    procedure EditExtrasTLou1Change(Sender: TObject);
    procedure EditExtrasTLou2Change(Sender: TObject);
    procedure EditExtrasLouLvChange(Sender: TObject);
    procedure EditExtrasToFaxChange(Sender: TObject);
    procedure EditExtrasHanvChange(Sender: TObject);
    procedure EditExtrasOrigChange(Sender: TObject);
    procedure EditExtrasAnswChange(Sender: TObject);
    procedure EditExtrasMdResChange(Sender: TObject);
    procedure MaskEditRemoteMasterChange(Sender: TObject);
    procedure MaskEditRemoteExt1Change(Sender: TObject);
    procedure MaskEditRemoteExt2Change(Sender: TObject);
    procedure CheckBoxRemoteExt1VLClick(Sender: TObject);
    procedure CheckBoxRemoteExt1VXClick(Sender: TObject);
    procedure CheckBoxRemoteExt1FPClick(Sender: TObject);
    procedure CheckBoxRemoteExt1FXClick(Sender: TObject);
    procedure CheckBoxRemoteExt1FNClick(Sender: TObject);
    procedure CheckBoxRemoteExt1OPClick(Sender: TObject);
    procedure CheckBoxRemoteExt2VLClick(Sender: TObject);
    procedure CheckBoxRemoteExt2VXClick(Sender: TObject);
    procedure CheckBoxRemoteExt2FPClick(Sender: TObject);
    procedure CheckBoxRemoteExt2FXClick(Sender: TObject);
    procedure CheckBoxRemoteExt2FNClick(Sender: TObject);
    procedure CheckBoxRemoteExt2OPClick(Sender: TObject);
    procedure EditMainIDChange(Sender: TObject);
    procedure EditReSendDialRes1Change(Sender: TObject);
    procedure EditReSendDialRes2Change(Sender: TObject);
    procedure EditReSendDialRes3Change(Sender: TObject);
    procedure EditReSendDialRes4Change(Sender: TObject);
    procedure CheckBoxWorkIdleExt1Click(Sender: TObject);
    procedure CheckBoxWorkIdleExt2Click(Sender: TObject);
    procedure RadioButtonWorkDisplayModem1Click(Sender: TObject);
    procedure RadioButtonWorkDisplayModem2Click(Sender: TObject);
    procedure RadioButtonWorkDisplayModem3Click(Sender: TObject);
    procedure RadioButtonRemoteOptronOnClick(Sender: TObject);
    procedure RadioButtonRemoteOptronOffClick(Sender: TObject);
    procedure ButtonExtrasSetClass1Click(Sender: TObject);
    procedure ButtonExtrasSetClass2Click(Sender: TObject);
    procedure RadioButtonPrinterType0Click(Sender: TObject);
    procedure RadioButtonPrinterType1Click(Sender: TObject);
    procedure RadioButtonPrinterType2Click(Sender: TObject);
    procedure RadioButtonPrinterType3Click(Sender: TObject);
    procedure RadioButtonPrinterType4Click(Sender: TObject);
    procedure RadioButtonPrinterType5Click(Sender: TObject);
    procedure RadioButtonPrinterType6Click(Sender: TObject);
    procedure RadioGroupPrinterLaserGClick(Sender: TObject);
    procedure RadioGroupPrinterLaserSClick(Sender: TObject);
    procedure RadioGroupPrinter24PinClick(Sender: TObject);
    procedure ButtonPrinterTestLaserGSClick(Sender: TObject);
    procedure ButtonPrinterTest24FeedClick(Sender: TObject);
    procedure MenuSetupQuitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuSetupMainClick(Sender: TObject);
    procedure MenuFaxResendClick(Sender: TObject);
    procedure MenuSetupPrinterClick(Sender: TObject);
    procedure MenuSetupExtrasClick(Sender: TObject);
    procedure CheckBoxWorkCoListenClick(Sender: TObject);
    procedure RadioButtonMainVolume1Click(Sender: TObject);
    procedure RadioButtonMainVolume2Click(Sender: TObject);
    procedure RadioButtonMainVolume3Click(Sender: TObject);
    procedure RadioGroupWorkActionClick(Sender: TObject);
    procedure RadioButtonEraseFaxNoClick(Sender: TObject);
    procedure RadioButtonEraseFaxYesClick(Sender: TObject);
    procedure BitBtnBasicSetupWriteClick(Sender: TObject);
    procedure BitBtnBasicSetupBreakClick(Sender: TObject);
    procedure CheckBoxReSend1Click(Sender: TObject);
    procedure CheckBoxWorkToneDialClick(Sender: TObject);
    procedure CheckBoxWorkIdleMasterClick(Sender: TObject);
    procedure RadioButtonDTRClick(Sender: TObject);
    procedure RadioButtonRTSClick(Sender: TObject);
    procedure RadioButtonDTRRTSClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Edit1ATTXRowChange(Sender: TObject);
    procedure Edit1ATRXRowChange(Sender: TObject);
    procedure EditATCPIChange(Sender: TObject);
    procedure ButtonM20Click(Sender: TObject);
    procedure CheckBoxDUMMYClick(Sender: TObject);
    procedure CheckBoxWorkEraseResendClick(Sender: TObject);
    procedure GroupBoxExtrasWatchSIOClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormBasicSetup: TFormBasicSetup;

Procedure SetupDevice;
Procedure SortParameters(EndString,CheckString : String; Var AssignString : TSetupString);
Procedure PutSetupParameter(WriteString : String; AssignString : TSetupString);
Procedure ReadSetup;
Procedure WriteSetup;
Procedure PresetSetupFlags;
Procedure UpDateBasicSetup;
Procedure ConvertBasicSetup;
Procedure DecideEnabling;

implementation

{$R *.DFM}

Procedure SetupDevice;
Begin
  UpdateAllowed:=False;
  ReadSetup;
  UpDateBasicSetup;
  UpdateAllowed:=True;
  DoneSetup:=False;
  DoneXSetup:=False;
  Repeat
    FormBasicSetup.ModalResult:=MyResSetupBasicNone;
    FormBasicSetup.ShowModal;
    If (FormBasicSetup.ModalResult=MyResSetupBasicSetC1) Or
       (FormBasicSetup.ModalResult=MyResSetupBasicSetM20) Then
      Begin
        AskSetDefaults;
        If (FormSetupDefaults.ModalResult=MyResSetupBasicAnsY) Then
          Begin
            FormWaitPleaseDefaults.Show;
            AskAndRead1s('[');
            WaitAndRead120s;
            FormWaitPleaseDefaults.Hide;
            UpdateAllowed:=False;
            ReadSetup;
            UpDateBasicSetup;
            UpdateAllowed:=True
          End
      End;
    If (FormBasicSetup.ModalResult=MyResSetupBasicSetC2) Then
      Begin
        AskSetDefaults;
        If (FormSetupDefaults.ModalResult=MyResSetupBasicAnsY) Then
          Begin
            FormWaitPleaseDefaults.Show;
            AskAndRead1s(']');
            WaitAndRead120s;
            FormWaitPleaseDefaults.Hide;
            UpdateAllowed:=False;
            ReadSetup;
            UpDateBasicSetup;
            UpdateAllowed:=True
          End
      End;
    If (FormBasicSetup.ModalResult=MyResSetupBasicTLas) Then
      Begin
        AskTestPrinter;
        If (FormTestPrinter.ModalResult=MyResSetupBasicAnsY) Then
          Begin
            FormWaitPleasePrinterTest.Show;
            AskAndRead1s('B');
            WaitAndRead120sWB;
            FormWaitPleasePrinterTest.Hide;
            If DeviceFailure Then
              Begin
                DeviceFailure:=False;
                WaitAndRead120s
              End;
            If DeviceFailure Then
              Begin
                DeviceFailure:=False;
                WaitAndRead120s
              End;
            FormWaitPleasePrinterTest.Hide
          End
      End;
    If (FormBasicSetup.ModalResult=MyResSetupBasicT24P) Then
      Begin
        AskTestPrinter;
        If (FormTestPrinter.ModalResult=MyResSetupBasicAnsY) Then
          Begin
            FormWaitPleasePrinterTest.Show;
            AskAndRead1s('A');
            WaitAndRead120sWB;
            FormWaitPleasePrinterTest.Hide;
            If DeviceFailure Then
              Begin
                DeviceFailure:=False;
                WaitAndRead120s
              End;
            If DeviceFailure Then
              Begin
                DeviceFailure:=False;
                WaitAndRead120s
              End;
            FormWaitPleasePrinterTest.Hide
          End
      End;
    If (FormBasicSetup.ModalResult=MyResSetupBasicWrite) Then
      Begin
        DeviceColdstartReq:=True;
        WriteSetup;
        DoneXSetup:=True;
        DoneSetup:=True
      End;
    If (FormBasicSetup.ModalResult=MyResSetupBasicBreak) Then
      Begin
        DoneXSetup:=False;
        DoneSetup:=True
      End;
  Until DeviceFailure Or
        DoneSetup
End;

Procedure SortParameters(EndString,CheckString : String; Var AssignString : TSetupString);
Begin
  AllSetupStrings:=False;
  If (Length(InputString)<7) Then
    Exit;
  If (Copy(InputString,1,5)=CheckString) Then
    Begin
      Inc(SetupPar);
      ActRGauge(SetupPar);
      Delete(InputString,1,6);
      AssignString.SString:=Copy(InputString,1,Length(InputString)-1);
      AssignString.Active:=True;
      Exit
    End;
  If (Copy(InputString,1,5)=EndString) Then
    Begin
      AllSetupStrings:=True;
      Exit
    End
End;

Procedure PutSetupParameter(WriteString : String; AssignString : TSetupString);
Begin
  Inc(SetupPar);
  ActWGauge(SetupPar);
  If Not(DeviceFailure) Then
    Begin
      SetupString:='#'+WriteString+':'+AssignString.SString+Cr;
      If AssignString.Changed Then
        AskAndRead5s(SetupString)
    End
  Else
    MessageBeep(0)
End;

Procedure ReadSetup;
Begin
  AskAndRead1s('\');
  If DeviceFailure Then
    Exit;
  FormReadSetup.Show;
  SetRGauge(NSetupPars);
  SetupPar:=0;
  PresetSetupFlags;
  Repeat
    AskAndRead5s('/');
    If DeviceFailure Then
      Exit;
    SortParameters('*****','IDENT',SetupString_IDENT);
    SortParameters('*****','NRES1',SetupString_NRES1);
    SortParameters('*****','NRES2',SetupString_NRES2);
    SortParameters('*****','NRES3',SetupString_NRES3);
    SortParameters('*****','NRES4',SetupString_NRES4);
    SortParameters('*****','DIAL1',SetupString_DIAL1);
    SortParameters('*****','DIAL2',SetupString_DIAL2);
    SortParameters('*****','DIAL3',SetupString_DIAL3);
    SortParameters('*****','DIAL4',SetupString_DIAL4);
    SortParameters('*****','MDRES',SetupString_MDRES);
    SortParameters('*****','ATRX1',SetupString_ATRX1);
    SortParameters('*****','ATRX2',SetupString_ATRX2);
    SortParameters('*****','ATRX3',SetupString_ATRX3);
    SortParameters('*****','ATTX1',SetupString_ATTX1);
    SortParameters('*****','ATTX2',SetupString_ATTX2);
    SortParameters('*****','ATTX3',SetupString_ATTX3);
    SortParameters('*****','AURTS',SetupString_AURTS);
    SortParameters('*****','AUDTR',SetupString_AUDTR);
    SortParameters('*****','FAXBR',SetupString_FAXBR);
    SortParameters('*****','FAXBS',SetupString_FAXBS);
    SortParameters('*****','NRING',SetupString_NRING);
    SortParameters('*****','FCLAS',SetupString_FCLAS);
    SortParameters('*****','PRINT',SetupString_PRINT);
    SortParameters('*****','LFD24',SetupString_LFD24);
    SortParameters('*****','LASRG',SetupString_LASRG);
    SortParameters('*****','LASRS',SetupString_LASRS);
    SortParameters('*****','ERRES',SetupString_ERRES);
    SortParameters('*****','DIALT',SetupString_DIALT);
    SortParameters('*****','FIRM1',SetupString_FIRM1);
    SortParameters('*****','FIRM2',SetupString_FIRM2);
    SortParameters('*****','FIRM3',SetupString_FIRM3);
    SortParameters('*****','LANGU',SetupString_LANGU);
    SortParameters('*****','EETES',SetupString_EETES);
    SortParameters('*****','ATCPI',SetupString_ATCPI);
    SortParameters('*****','DUMMY',SetupString_DUMMY);
  Until AllSetupStrings;
  DecideEnabling;
  FormReadSetup.Hide
End;

Procedure WriteSetup;
Begin
  FormWriteSetup.Show;
  SetWGauge(NSetupPars);
  SetupPar:=0;
  Repeat
    PutSetupParameter('IDENT',SetupString_IDENT);
    PutSetupParameter('NRES1',SetupString_NRES1);
    PutSetupParameter('NRES2',SetupString_NRES2);
    PutSetupParameter('NRES3',SetupString_NRES3);
    PutSetupParameter('NRES4',SetupString_NRES4);
    PutSetupParameter('DIAL1',SetupString_DIAL1);
    PutSetupParameter('DIAL2',SetupString_DIAL2);
    PutSetupParameter('DIAL3',SetupString_DIAL3);
    PutSetupParameter('DIAL4',SetupString_DIAL4);
    PutSetupParameter('MDRES',SetupString_MDRES);
    PutSetupParameter('ATRX1',SetupString_ATRX1);
    PutSetupParameter('ATRX2',SetupString_ATRX2);
    PutSetupParameter('ATRX3',SetupString_ATRX3);
    PutSetupParameter('ATTX1',SetupString_ATTX1);
    PutSetupParameter('ATTX2',SetupString_ATTX2);
    PutSetupParameter('ATTX3',SetupString_ATTX3);
    PutSetupParameter('AURTS',SetupString_AURTS);
    PutSetupParameter('AUDTR',SetupString_AUDTR);
    PutSetupParameter('FAXBR',SetupString_FAXBR);
    PutSetupParameter('FAXBS',SetupString_FAXBS);
    PutSetupParameter('NRING',SetupString_NRING);
    PutSetupParameter('FCLAS',SetupString_FCLAS);
    PutSetupParameter('PRINT',SetupString_PRINT);
    PutSetupParameter('LFD24',SetupString_LFD24);
    PutSetupParameter('LASRG',SetupString_LASRG);
    PutSetupParameter('LASRS',SetupString_LASRS);
    PutSetupParameter('ERRES',SetupString_ERRES);
    PutSetupParameter('DIALT',SetupString_DIALT);
    PutSetupParameter('FIRM1',SetupString_FIRM1);
    PutSetupParameter('FIRM2',SetupString_FIRM2);
    PutSetupParameter('FIRM3',SetupString_FIRM3);
    PutSetupParameter('LANGU',SetupString_LANGU);
    PutSetupParameter('EETES',SetupString_EETES);
    PutSetupParameter('ATCPI',SetupString_ATCPI);
    PutSetupParameter('DUMMY',SetupString_DUMMY)
  Until AllSetupStrings;
  FormWriteSetup.Hide
End;

Procedure PresetSString(Var S : TSetupString);
Begin
  With S Do
    Begin
      SString:='';
      Changed:=False;
      Active:=False
    End
End;

Procedure PresetSetupFlags;
Begin
  PresetSString(SetupString_IDENT);
  PresetSString(SetupString_NRES1);
  PresetSString(SetupString_NRES2);
  PresetSString(SetupString_NRES3);
  PresetSString(SetupString_NRES4);
  PresetSString(SetupString_DIAL1);
  PresetSString(SetupString_DIAL2);
  PresetSString(SetupString_DIAL3);
  PresetSString(SetupString_DIAL4);
  PresetSString(SetupString_MDRES);
  PresetSString(SetupString_ATRX1);
  PresetSString(SetupString_ATRX2);
  PresetSString(SetupString_ATRX3);
  PresetSString(SetupString_ATTX1);
  PresetSString(SetupString_ATTX2);
  PresetSString(SetupString_ATTX3);
  PresetSString(SetupString_AURTS);
  PresetSString(SetupString_AUDTR);
  PresetSString(SetupString_FAXBR);
  PresetSString(SetupString_FAXBS);
  PresetSString(SetupString_NRING);
  PresetSString(SetupString_FCLAS);
  PresetSString(SetupString_PRINT);
  PresetSString(SetupString_LFD24);
  PresetSString(SetupString_LASRG);
  PresetSString(SetupString_LASRS);
  PresetSString(SetupString_ERRES);
  PresetSString(SetupString_DIALT);
  PresetSString(SetupString_FIRM1);
  PresetSString(SetupString_FIRM2);
  PresetSString(SetupString_FIRM3);
  PresetSString(SetupString_LANGU);
  PresetSString(SetupString_EETES);
  PresetSString(SetupString_ATCPI);
  PresetSString(SetupString_DUMMY)
End;

Procedure UpDateBasicSetup;
Begin
  With FormBasicSetup Do
    Begin
      EditMainID.Text:=SetupString_IDENT.SString;
      EditMainNRing.Text:=SetupString_NRING.SString;
      EditExtrasFaxClass.Text:=SetupString_FCLAS.SString;
      EditReSendDialRes1.Text:=SetupString_DIAL1.SString;
      EditReSendDialRes2.Text:=SetupString_DIAL2.SString;
      EditReSendDialRes3.Text:=SetupString_DIAL3.SString;
      EditReSendDialRes4.Text:=SetupString_DIAL4.SString;
      Edit1ATRXRow.Text:=SetupString_ATRX1.SString;
      Edit1ATTXRow.Text:=SetupString_ATTX1.SString;
      EditReSendNResend1.Text:=SetupString_NRES1.SString;
      EditReSendNResend2.Text:=SetupString_NRES2.SString;
      EditReSendNResend3.Text:=SetupString_NRES3.SString;
      EditReSendNResend4.Text:=SetupString_NRES4.SString;
      If (SetupString_FAXBR.SString='0') Then
                                           RadioGroupRXBPS.ItemIndex:=0;
      If (SetupString_FAXBR.SString='1') Then
                                           RadioGroupRXBPS.ItemIndex:=1;
      If (SetupString_FAXBR.SString='2') Then
                                           RadioGroupRXBPS.ItemIndex:=2;
      If (SetupString_FAXBR.SString='3') Then
                                           RadioGroupRXBPS.ItemIndex:=3;
      If (SetupString_FAXBR.SString='4') Then
                                           RadioGroupRXBPS.ItemIndex:=4;
      If (SetupString_FAXBR.SString='5') Then
                                           RadioGroupRXBPS.ItemIndex:=5;
      If (SetupString_FAXBS.SString='0') Then
                                           RadioGroupTXBPS.ItemIndex:=0;
      If (SetupString_FAXBS.SString='1') Then
                                           RadioGroupTXBPS.ItemIndex:=1;
      If (SetupString_FAXBS.SString='2') Then
                                           RadioGroupTXBPS.ItemIndex:=2;
      If (SetupString_FAXBS.SString='3') Then
                                           RadioGroupTXBPS.ItemIndex:=3;
      If (SetupString_FAXBS.SString='4') Then
                                           RadioGroupTXBPS.ItemIndex:=4;
      If (SetupString_FAXBS.SString='5') Then
                                           RadioGroupTXBPS.ItemIndex:=5;
      If ((SetupString_AURTS.SString='0') And
         (SetupString_AUDTR.SString='1')) Then
                                           RadioButtonDTR.Checked:=True;
      If ((SetupString_AURTS.SString='1') And
         (SetupString_AUDTR.SString='0')) Then
                                           RadioButtonRTS.Checked:=True;
      If ((SetupString_AURTS.SString='1') And
         (SetupString_AUDTR.SString='1')) Then
                                           RadioButtonDTRRTS.Checked:=True;
      If (SetupString_DIALT.SString='1') Then
                                           CheckBoxWorkToneDial.Checked:=True
                                         Else
                                           CheckBoxWorkToneDial.Checked:=False;
      If (SetupString_ERRES.SString='1') Then
                                           CheckBoxWorkEraseResend.Checked:=True
                                         Else
                                           CheckBoxWorkEraseResend.Checked:=False;
      If (SetupString_PRINT.SString='0') Then
                                           RadioButtonPrinterType0.Checked:=True;
      If (SetupString_PRINT.SString='1') Then
                                           RadioButtonPrinterType1.Checked:=True;
      If (SetupString_PRINT.SString='2') Then
                                           RadioButtonPrinterType2.Checked:=True;
      If (SetupString_PRINT.SString='3') Then
                                           RadioButtonPrinterType3.Checked:=True;
      If (SetupString_PRINT.SString='4') Then
                                           RadioButtonPrinterType4.Checked:=True;
      If (SetupString_PRINT.SString='5') Then
                                           RadioButtonPrinterType5.Checked:=True;
      If (SetupString_PRINT.SString='6') Then
                                           RadioButtonPrinterType6.Checked:=True;
      If (SetupString_LASRG.SString='1') Then
                                           RadioGroupPrinterLaserG.ItemIndex:=0;
      If (SetupString_LASRG.SString='2') Then
                                           RadioGroupPrinterLaserG.ItemIndex:=1;
      If (SetupString_LASRG.SString='3') Then
                                           RadioGroupPrinterLaserG.ItemIndex:=2;
      If (SetupString_LASRG.SString='4') Then
                                           RadioGroupPrinterLaserG.ItemIndex:=3;
      If (SetupString_LASRG.SString='5') Then
                                           RadioGroupPrinterLaserG.ItemIndex:=4;
      If (SetupString_LASRS.SString='1') Then
                                           RadioGroupPrinterLaserS.ItemIndex:=0;
      If (SetupString_LASRS.SString='2') Then
                                           RadioGroupPrinterLaserS.ItemIndex:=1;
      If (SetupString_LASRS.SString='3') Then
                                           RadioGroupPrinterLaserS.ItemIndex:=2;
      If (SetupString_LASRS.SString='4') Then
                                           RadioGroupPrinterLaserS.ItemIndex:=3;
      If (SetupString_LASRS.SString='5') Then
                                           RadioGroupPrinterLaserS.ItemIndex:=4;
      If (SetupString_LFD24.SString='A') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=0;
      If (SetupString_LFD24.SString='B') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=1;
      If (SetupString_LFD24.SString='C') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=2;
      If (SetupString_LFD24.SString='D') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=3;
      If (SetupString_LFD24.SString='E') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=4;
      If (SetupString_LFD24.SString='F') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=5;
      If (SetupString_LFD24.SString='G') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=6;
      If (SetupString_LFD24.SString='H') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=7;
      If (SetupString_LFD24.SString='I') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=8;
      If (SetupString_LFD24.SString='J') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=9;
      If (SetupString_LFD24.SString='K') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=10;
      If (SetupString_LFD24.SString='L') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=11;
      If (SetupString_LFD24.SString='M') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=12;
      If (SetupString_LFD24.SString='N') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=13;
      If (SetupString_LFD24.SString='O') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=14;
      If (SetupString_LFD24.SString='P') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=15;
      If (SetupString_LFD24.SString='Q') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=16;
      If (SetupString_LFD24.SString='R') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=17;
      If (SetupString_LFD24.SString='S') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=18;
      If (SetupString_LFD24.SString='T') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=19;
      If (SetupString_LFD24.SString='U') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=20;
      If (SetupString_LFD24.SString='V') Then
                                           RadioGroupPrinter24Pin.ItemIndex:=21;
      EditATCPI.Text:=SetupString_ATCPI.SString;
      If (SetupString_DUMMY.SString='1') Then
                                           CheckBoxDUMMY.Checked:=True
                                         Else
                                           CheckBoxDUMMY.Checked:=False;
    End;
  Application.ProcessMessages
End;

Procedure ConvertBasicSetup;
Begin
  If Not(UpdateAllowed) Then
    Exit;
  With FormBasicSetup Do
    Begin
      If (SetupString_IDENT.SString<>EditMainID.Text) Then
        Begin
          SetupString_IDENT.SString:=EditMainID.Text;
          SetupString_IDENT.Changed:=True
        End;
      If (SetupString_NRING.SString<>EditMainNRing.Text) Then
        Begin
          SetupString_NRING.SString:=EditMainNRing.Text;
          SetupString_NRING.Changed:=True
        End;
      If (SetupString_FCLAS.SString<>EditExtrasFaxClass.Text) Then
        Begin
          SetupString_FCLAS.SString:=EditExtrasFaxClass.Text;
          SetupString_FCLAS.Changed:=True
        End;
      If (SetupString_DIAL1.SString<>EditReSendDialRes1.Text) Then
        Begin
          SetupString_DIAL1.SString:=EditReSendDialRes1.Text;
          SetupString_DIAL1.Changed:=True
        End;
      If (SetupString_DIAL2.SString<>EditReSendDialRes2.Text) Then
        Begin
          SetupString_DIAL2.SString:=EditReSendDialRes2.Text;
          SetupString_DIAL2.Changed:=True
        End;
      If (SetupString_DIAL3.SString<>EditReSendDialRes3.Text) Then
        Begin
          SetupString_DIAL3.SString:=EditReSendDialRes3.Text;
          SetupString_DIAL3.Changed:=True
        End;
      If (SetupString_DIAL4.SString<>EditReSendDialRes4.Text) Then
        Begin
          SetupString_DIAL4.SString:=EditReSendDialRes4.Text;
          SetupString_DIAL4.Changed:=True
        End;
      If (SetupString_ATRX1.SString<>Edit1ATRXRow.Text) Then
        Begin
          SetupString_ATRX1.SString:=Edit1ATRXRow.Text;
          SetupString_ATRX1.Changed:=True
        End;
      If (SetupString_ATTX1.SString<>Edit1ATTXRow.Text) Then
        Begin
          SetupString_ATTX1.SString:=Edit1ATTXRow.Text;
          SetupString_ATTX1.Changed:=True
        End;
      If (SetupString_NRES1.SString<>EditReSendNResend1.Text) Then
        Begin
          SetupString_NRES1.SString:=EditReSendNResend1.Text;
          SetupString_NRES1.Changed:=True
        End;
      If (SetupString_NRES2.SString<>EditReSendNResend2.Text) Then
        Begin
          SetupString_NRES2.SString:=EditReSendNResend2.Text;
          SetupString_NRES2.Changed:=True
        End;
      If (SetupString_NRES3.SString<>EditReSendNResend3.Text) Then
        Begin
          SetupString_NRES3.SString:=EditReSendNResend3.Text;
          SetupString_NRES3.Changed:=True
        End;
      If (SetupString_NRES4.SString<>EditReSendNResend4.Text) Then
        Begin
          SetupString_NRES4.SString:=EditReSendNResend4.Text;
          SetupString_NRES4.Changed:=True
        End;

      Case RadioGroupRXBPS.ItemIndex Of
        0 : If (SetupString_FAXBR.SString<>'0') Then
              SetupString_FAXBR.Changed:=True;
        1 : If (SetupString_FAXBR.SString<>'1') Then
              SetupString_FAXBR.Changed:=True;
        2 : If (SetupString_FAXBR.SString<>'2') Then
              SetupString_FAXBR.Changed:=True;
        3 : If (SetupString_FAXBR.SString<>'3') Then
              SetupString_FAXBR.Changed:=True;
        4 : If (SetupString_FAXBR.SString<>'4') Then
              SetupString_FAXBR.Changed:=True;
        5 : If (SetupString_FAXBR.SString<>'5') Then
              SetupString_FAXBR.Changed:=True
      End;
      Case RadioGroupRXBPS.ItemIndex Of
        0 : SetupString_FAXBR.SString:='0';
        1 : SetupString_FAXBR.SString:='1';
        2 : SetupString_FAXBR.SString:='2';
        3 : SetupString_FAXBR.SString:='3';
        4 : SetupString_FAXBR.SString:='4';
        5 : SetupString_FAXBR.SString:='5'
      End;

      Case RadioGroupTXBPS.ItemIndex Of
        0 : If (SetupString_FAXBS.SString<>'0') Then
              SetupString_FAXBS.Changed:=True;
        1 : If (SetupString_FAXBS.SString<>'1') Then
              SetupString_FAXBS.Changed:=True;
        2 : If (SetupString_FAXBS.SString<>'2') Then
              SetupString_FAXBS.Changed:=True;
        3 : If (SetupString_FAXBS.SString<>'3') Then
              SetupString_FAXBS.Changed:=True;
        4 : If (SetupString_FAXBS.SString<>'4') Then
              SetupString_FAXBS.Changed:=True;
        5 : If (SetupString_FAXBS.SString<>'5') Then
              SetupString_FAXBS.Changed:=True
      End;

      Case RadioGroupTXBPS.ItemIndex Of
        0 : SetupString_FAXBS.SString:='0';
        1 : SetupString_FAXBS.SString:='1';
        2 : SetupString_FAXBS.SString:='2';
        3 : SetupString_FAXBS.SString:='3';
        4 : SetupString_FAXBS.SString:='4';
        5 : SetupString_FAXBS.SString:='5'
      End;

      If ((RadioButtonDTR.Checked) Or (RadioButtonDTRRTS.Checked)) And
         (SetupString_AUDTR.SString='0') Then
                                           Begin
                                             SetupString_AUDTR.Changed:=True;
                                             SetupString_AURTS.Changed:=True
                                           End;
      If ((RadioButtonRTS.Checked) Or (RadioButtonDTRRTS.Checked)) And
         (SetupString_AURTS.SString='0') Then
                                           Begin
                                             SetupString_AUDTR.Changed:=True;
                                             SetupString_AURTS.Changed:=True
                                           End;
      If (RadioButtonDTR.Checked) And
         ( (SetupString_AUDTR.SString<>'1') Or
           (SetupString_AURTS.SString<>'0')    )
        Then
          Begin
            SetupString_AUDTR.Changed:=True;
            SetupString_AURTS.Changed:=True;
            SetupString_AUDTR.SString:='1';
            SetupString_AURTS.SString:='0'
          End;
      If (RadioButtonRTS.Checked) And
         ( (SetupString_AUDTR.SString<>'0') Or
           (SetupString_AURTS.SString<>'1')    )
        Then
          Begin
            SetupString_AUDTR.Changed:=True;
            SetupString_AURTS.Changed:=True;
            SetupString_AUDTR.SString:='0';
            SetupString_AURTS.SString:='1'
          End;
      If (RadioButtonDTRRTS.Checked) And
         ( (SetupString_AUDTR.SString<>'1') Or
           (SetupString_AURTS.SString<>'1')    )
        Then
          Begin
            SetupString_AUDTR.Changed:=True;
            SetupString_AURTS.Changed:=True;
            SetupString_AUDTR.SString:='1';
            SetupString_AURTS.SString:='1'
          End;

      If (Length(SetupString_PRINT.SString)<>0) Then
        Case SetupString_PRINT.SString[1] Of
         '0' : If Not(RadioButtonPrinterType0.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '1' : If Not(RadioButtonPrinterType1.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '2' : If Not(RadioButtonPrinterType2.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '3' : If Not(RadioButtonPrinterType3.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '4' : If Not(RadioButtonPrinterType4.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '5' : If Not(RadioButtonPrinterType5.Checked) Then
                 SetupString_PRINT.Changed:=True;
         '6' : If Not(RadioButtonPrinterType6.Checked) Then
                 SetupString_PRINT.Changed:=True
        End;
      If RadioButtonPrinterType0.Checked Then
        SetupString_PRINT.SString:='0';
      If RadioButtonPrinterType1.Checked Then
        SetupString_PRINT.SString:='1';
      If RadioButtonPrinterType2.Checked Then
        SetupString_PRINT.SString:='2';
      If RadioButtonPrinterType3.Checked Then
        SetupString_PRINT.SString:='3';
      If RadioButtonPrinterType4.Checked Then
        SetupString_PRINT.SString:='4';
      If RadioButtonPrinterType5.Checked Then
        SetupString_PRINT.SString:='5';
      If RadioButtonPrinterType6.Checked Then
        SetupString_PRINT.SString:='6';

      Case RadioGroupPrinterLaserG.ItemIndex Of
        0 : If (SetupString_LASRG.SString<>'1') Then
              SetupString_LASRG.Changed:=True;
        1 : If (SetupString_LASRG.SString<>'2') Then
              SetupString_LASRG.Changed:=True;
        2 : If (SetupString_LASRG.SString<>'3') Then
              SetupString_LASRG.Changed:=True;
        3 : If (SetupString_LASRG.SString<>'4') Then
              SetupString_LASRG.Changed:=True;
        4 : If (SetupString_LASRG.SString<>'5') Then
              SetupString_LASRG.Changed:=True
      End;
      Case RadioGroupPrinterLaserG.ItemIndex Of
        0 : SetupString_LASRG.SString:='1';
        1 : SetupString_LASRG.SString:='2';
        2 : SetupString_LASRG.SString:='3';
        3 : SetupString_LASRG.SString:='4';
        4 : SetupString_LASRG.SString:='5'
      End;

      If CheckBoxWorkToneDial.Checked And
         (SetupString_DIALT.SString<>'1') Then
         SetupString_DIALT.Changed:=True;
      If Not(CheckBoxWorkToneDial.Checked) And
         (SetupString_DIALT.SString<>'0') Then
         SetupString_DIALT.Changed:=True;
      If CheckBoxWorkToneDial.Checked Then
        SetupString_DIALT.SString:='1'
      Else
        SetupString_DIALT.SString:='0';

      If CheckBoxWorkEraseResend.Checked And
         (SetupString_ERRES.SString<>'1') Then
         SetupString_ERRES.Changed:=True;
      If Not(CheckBoxWorkEraseResend.Checked) And
         (SetupString_ERRES.SString<>'0') Then
         SetupString_ERRES.Changed:=True;
      If CheckBoxWorkEraseResend.Checked Then
        SetupString_ERRES.SString:='1'
      Else
        SetupString_ERRES.SString:='0';

      Case RadioGroupPrinterLaserS.ItemIndex Of
        0 : If (SetupString_LASRS.SString<>'1') Then
              SetupString_LASRS.Changed:=True;
        1 : If (SetupString_LASRS.SString<>'2') Then
              SetupString_LASRS.Changed:=True;
        2 : If (SetupString_LASRS.SString<>'3') Then
              SetupString_LASRS.Changed:=True;
        3 : If (SetupString_LASRS.SString<>'4') Then
              SetupString_LASRS.Changed:=True;
        4 : If (SetupString_LASRS.SString<>'5') Then
              SetupString_LASRS.Changed:=True
      End;
      Case RadioGroupPrinterLaserS.ItemIndex Of
        0 : SetupString_LASRS.SString:='1';
        1 : SetupString_LASRS.SString:='2';
        2 : SetupString_LASRS.SString:='3';
        3 : SetupString_LASRS.SString:='4';
        4 : SetupString_LASRS.SString:='5'
      End;

      Case RadioGroupPrinter24Pin.ItemIndex Of
        0 : If (SetupString_LFD24.SString<>'A') Then
              SetupString_LFD24.Changed:=True;
        1 : If (SetupString_LFD24.SString<>'B') Then
              SetupString_LFD24.Changed:=True;
        2 : If (SetupString_LFD24.SString<>'C') Then
              SetupString_LFD24.Changed:=True;
        3 : If (SetupString_LFD24.SString<>'D') Then
              SetupString_LFD24.Changed:=True;
        4 : If (SetupString_LFD24.SString<>'E') Then
              SetupString_LFD24.Changed:=True;
        5 : If (SetupString_LFD24.SString<>'F') Then
              SetupString_LFD24.Changed:=True;
        6 : If (SetupString_LFD24.SString<>'G') Then
              SetupString_LFD24.Changed:=True;
        7 : If (SetupString_LFD24.SString<>'H') Then
              SetupString_LFD24.Changed:=True;
        8 : If (SetupString_LFD24.SString<>'I') Then
              SetupString_LFD24.Changed:=True;
        9 : If (SetupString_LFD24.SString<>'J') Then
              SetupString_LFD24.Changed:=True;
       10 : If (SetupString_LFD24.SString<>'K') Then
              SetupString_LFD24.Changed:=True;
       11 : If (SetupString_LFD24.SString<>'L') Then
              SetupString_LFD24.Changed:=True;
       12 : If (SetupString_LFD24.SString<>'M') Then
              SetupString_LFD24.Changed:=True;
       13 : If (SetupString_LFD24.SString<>'N') Then
              SetupString_LFD24.Changed:=True;
       14 : If (SetupString_LFD24.SString<>'O') Then
              SetupString_LFD24.Changed:=True;
       15 : If (SetupString_LFD24.SString<>'P') Then
              SetupString_LFD24.Changed:=True;
       16 : If (SetupString_LFD24.SString<>'Q') Then
              SetupString_LFD24.Changed:=True;
       17 : If (SetupString_LFD24.SString<>'R') Then
              SetupString_LFD24.Changed:=True;
       18 : If (SetupString_LFD24.SString<>'S') Then
              SetupString_LFD24.Changed:=True;
       19 : If (SetupString_LFD24.SString<>'T') Then
              SetupString_LFD24.Changed:=True;
       20 : If (SetupString_LFD24.SString<>'U') Then
              SetupString_LFD24.Changed:=True;
       21 : If (SetupString_LFD24.SString<>'V') Then
              SetupString_LFD24.Changed:=True
      End;

      Case RadioGroupPrinter24Pin.ItemIndex Of
        0 : SetupString_LFD24.SString:='A';
        1 : SetupString_LFD24.SString:='B';
        2 : SetupString_LFD24.SString:='C';
        3 : SetupString_LFD24.SString:='D';
        4 : SetupString_LFD24.SString:='E';
        5 : SetupString_LFD24.SString:='F';
        6 : SetupString_LFD24.SString:='G';
        7 : SetupString_LFD24.SString:='H';
        8 : SetupString_LFD24.SString:='I';
        9 : SetupString_LFD24.SString:='J';
       10 : SetupString_LFD24.SString:='K';
       11 : SetupString_LFD24.SString:='L';
       12 : SetupString_LFD24.SString:='M';
       13 : SetupString_LFD24.SString:='N';
       14 : SetupString_LFD24.SString:='O';
       15 : SetupString_LFD24.SString:='P';
       16 : SetupString_LFD24.SString:='Q';
       17 : SetupString_LFD24.SString:='R';
       18 : SetupString_LFD24.SString:='S';
       19 : SetupString_LFD24.SString:='T';
       20 : SetupString_LFD24.SString:='U';
       21 : SetupString_LFD24.SString:='V'
      End;

      If (SetupString_ATCPI.SString<>EditATCPI.Text) Then
        Begin
          SetupString_ATCPI.SString:=EditATCPI.Text;
          SetupString_ATCPI.Changed:=True
        End;

      If CheckBoxDUMMY.Checked And
         (SetupString_DUMMY.SString<>'1') Then
         SetupString_DUMMY.Changed:=True;
      If Not(CheckBoxDUMMY.Checked) And
         (SetupString_DUMMY.SString<>'0') Then
         SetupString_DUMMY.Changed:=True;
      If CheckBoxDUMMY.Checked Then
        SetupString_DUMMY.SString:='1'
      Else
        SetupString_DUMMY.SString:='0'

    End;
  Application.ProcessMessages
End;

Procedure DecideEnabling;
Begin
  With FormBasicSetup Do
    Begin
      EditMainID.Enabled:=SetupString_IDENT.Active;
      EditMainNRing.Enabled:=SetupString_NRING.Active;
      EditExtrasFaxClass.Enabled:=SetupString_FCLAS.Active;
      EditReSendDialRes1.Enabled:=SetupString_DIAL1.Active;
      EditReSendDialRes2.Enabled:=SetupString_DIAL2.Active;
      EditReSendDialRes3.Enabled:=SetupString_DIAL3.Active;
      EditReSendDialRes4.Enabled:=SetupString_DIAL4.Active;
      Edit1ATRXRow.Enabled:=SetupString_ATRX1.Active;
      Edit1ATTXRow.Enabled:=SetupString_ATTX1.Active;
      EditReSendNResend1.Enabled:=SetupString_NRES1.Active;
      EditReSendNResend2.Enabled:=SetupString_NRES2.Active;
      EditReSendNResend3.Enabled:=SetupString_NRES3.Active;
      EditReSendNResend4.Enabled:=SetupString_NRES4.Active;
      RadioGroupRXBPS.Enabled:=SetupString_FAXBR.Active;
      RadioGroupTXBPS.Enabled:=SetupString_FAXBS.Active;
      RadioButtonDTR.Enabled:=SetupString_AUDTR.Active;
      RadioButtonRTS.Enabled:=SetupString_AURTS.Active;
      RadioButtonDTRRTS.Enabled:=SetupString_AUDTR.Active AND SetupString_AURTS.Active;
      RadioButtonPrinterType0.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType1.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType2.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType3.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType4.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType5.Enabled:=SetupString_PRINT.Active;
      RadioButtonPrinterType6.Enabled:=SetupString_PRINT.Active;
      RadioGroupPrinterLaserG.Enabled:=SetupString_LASRG.Active;
      CheckBoxWorkToneDial.Enabled:=SetupString_DIALT.Active;
      CheckBoxWorkEraseResend.Enabled:=SetupString_ERRES.Active;
      RadioGroupPrinterLaserS.Enabled:=SetupString_LASRS.Active;
      RadioGroupPrinter24Pin.Enabled:=SetupString_LFD24.Active;
      EditATCPI.Enabled:=SetupString_ATCPI.Active;
      ButtonM20.Enabled:=SetupString_ATCPI.Active;
      LabelCPIN.Enabled:=SetupString_ATCPI.Active;
      CheckBoxDUMMY.Enabled:=SetupString_DUMMY.Active
    End;
End;

procedure TFormBasicSetup.SpinButtonMainNRingDownClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditMainNRing.Text);
  If (SetupPar>0) Then
    Begin
      Dec(SetupPar);
      EditMainNRing.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonMainNRingUpClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditMainNRing.Text);
  If (SetupPar<6) Then
    Begin
      Inc(SetupPar);
      EditMainNRing.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend1DownClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend1.Text);
  If (SetupPar>0) Then
    Begin
      Dec(SetupPar);
      EditReSendNResend1.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend2DownClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend2.Text);
  If (SetupPar>0) Then
    Begin
      Dec(SetupPar);
      EditReSendNResend2.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend3DownClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend3.Text);
  If (SetupPar>0) Then
    Begin
      Dec(SetupPar);
      EditReSendNResend3.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend4DownClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend4.Text);
  If (SetupPar>0) Then
    Begin
      Dec(SetupPar);
      EditReSendNResend4.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend1UpClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend1.Text);
  If (SetupPar<9) Then
    Begin
      Inc(SetupPar);
      EditReSendNResend1.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend2UpClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend2.Text);
  If (SetupPar<9) Then
    Begin
      Inc(SetupPar);
      EditReSendNResend2.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend3UpClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend3.Text);
  If (SetupPar<9) Then
    Begin
      Inc(SetupPar);
      EditReSendNResend3.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.SpinButtonReSend4UpClick(Sender: TObject);
begin
  SetupPar:=StrToInt(EditReSendNResend4.Text);
  If (SetupPar<9) Then
    Begin
      Inc(SetupPar);
      EditReSendNResend4.Text:=IntToStr(SetupPar);
      ConvertBasicSetup
    End
  Else
    WarningBeep
end;

procedure TFormBasicSetup.CheckBoxExtrasAutoSerClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupRXBPSClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupTXBPSClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasVoiceOnChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasVoiceParChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasRMic1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasRMic2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasRLin1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasRLin2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasTLin1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasTLin2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasTLou1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasTLou2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasLouLvChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasToFaxChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasHanvChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasOrigChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasAnswChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditExtrasMdResChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.MaskEditRemoteMasterChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.MaskEditRemoteExt1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.MaskEditRemoteExt2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1VLClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1VXClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1FPClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1FXClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1FNClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt1OPClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2VLClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2VXClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2FPClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2FXClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2FNClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxRemoteExt2OPClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditMainIDChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditReSendDialRes1Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditReSendDialRes2Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditReSendDialRes3Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditReSendDialRes4Change(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxWorkIdleExt1Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxWorkIdleExt2Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonWorkDisplayModem1Click(
  Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonWorkDisplayModem2Click(
  Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonWorkDisplayModem3Click(
  Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonRemoteOptronOnClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonRemoteOptronOffClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.ButtonExtrasSetClass1Click(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicSetC1
end;

procedure TFormBasicSetup.ButtonExtrasSetClass2Click(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicSetC2
end;

procedure TFormBasicSetup.RadioButtonPrinterType0Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType1Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType2Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType3Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType4Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType5Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonPrinterType6Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupPrinterLaserGClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupPrinterLaserSClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupPrinter24PinClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.ButtonPrinterTestLaserGSClick(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicTLas
end;

procedure TFormBasicSetup.ButtonPrinterTest24FeedClick(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicT24P
end;

procedure TFormBasicSetup.MenuSetupQuitClick(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicBreak
end;

procedure TFormBasicSetup.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If (FormBasicSetup.ModalResult=MyResSetupBasicNone) Or
     (FormBasicSetup.ModalResult=mrCancel) Then
    FormBasicSetup.ModalResult:=MyResSetupBasicBreak
end;

procedure TFormBasicSetup.MenuSetupMainClick(Sender: TObject);
begin
  FormBasicSetup.TabbedNotebookBSetup.PageIndex:=0
end;

procedure TFormBasicSetup.MenuFaxResendClick(Sender: TObject);
begin
  FormBasicSetup.TabbedNotebookBSetup.PageIndex:=1
end;

procedure TFormBasicSetup.MenuSetupPrinterClick(Sender: TObject);
begin
  FormBasicSetup.TabbedNotebookBSetup.PageIndex:=2
end;

procedure TFormBasicSetup.MenuSetupExtrasClick(Sender: TObject);
begin
  FormBasicSetup.TabbedNotebookBSetup.PageIndex:=3
end;

procedure TFormBasicSetup.CheckBoxWorkCoListenClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonMainVolume1Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonMainVolume2Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonMainVolume3Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioGroupWorkActionClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonEraseFaxNoClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonEraseFaxYesClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.BitBtnBasicSetupWriteClick(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicWrite
end;

procedure TFormBasicSetup.BitBtnBasicSetupBreakClick(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicBreak
end;

procedure TFormBasicSetup.CheckBoxReSend1Click(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxWorkToneDialClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxWorkIdleMasterClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonDTRClick(Sender: TObject);
begin
  SetupString_AUDTR.Changed:=True;
  SetupString_AURTS.Changed:=True;
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonRTSClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.RadioButtonDTRRTSClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.FormShow(Sender: TObject);
begin
  If RTSDTR Then
    Begin
      FormBasicSetup.RadioButtonDTR.Enabled:=True;
      FormBasicSetup.RadioButtonRTS.Enabled:=True;
      FormBasicSetup.RadioButtonDTRRTS.Enabled:=True
    End
  Else
    Begin
      FormBasicSetup.RadioButtonDTR.Enabled:=False;
      FormBasicSetup.RadioButtonRTS.Enabled:=False;
      FormBasicSetup.RadioButtonDTRRTS.Enabled:=False
    End
end;

procedure TFormBasicSetup.Edit1ATTXRowChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.Edit1ATRXRowChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.EditATCPIChange(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.ButtonM20Click(Sender: TObject);
begin
  FormBasicSetup.ModalResult:=MyResSetupBasicSetM20
end;

procedure TFormBasicSetup.CheckBoxDUMMYClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.CheckBoxWorkEraseResendClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

procedure TFormBasicSetup.GroupBoxExtrasWatchSIOClick(Sender: TObject);
begin
  ConvertBasicSetup
end;

end.
