unit Unittime;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Unitglob,
  ExtCtrls;

type
  TFormTime = class(TForm)
    Timer50ms:   TTimer;
    Timer200ms:  TTimer;
    Timer500ms:  TTimer;
    Timer1000ms: TTimer;
    Timer2000ms: TTimer;
    Timer5000ms: TTimer;
    Timer16000ms: TTimer;
    Timer60000ms: TTimer;
    procedure Timer50msTimer(Sender: TObject);
    procedure Timer200msTimer(Sender: TObject);
    procedure Timer500msTimer(Sender: TObject);
    procedure Timer1000msTimer(Sender: TObject);
    procedure Timer2000msTimer(Sender: TObject);
    procedure Timer5000msTimer(Sender: TObject);
    procedure Timer16000msTimer(Sender: TObject);
    procedure Timer60000msTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormTime: TFormTime;

Procedure RestartTimer50ms;
Procedure RestartTimer200ms;
Procedure RestartTimer500ms;
Procedure RestartTimer1000ms;
Procedure RestartTimer2000ms;
Procedure RestartTimer5000ms;
Procedure RestartTimer16000ms;
Procedure RestartTimer60000ms;

implementation

{$R *.DFM}

Procedure RestartTimer50ms;
Begin
  FormTime.Timer50ms.Enabled:=False;
  FormTime.Timer50ms.Interval:=50;
  Timeout50ms:=False;
  FormTime.Timer50ms.Enabled:=True
End;

Procedure RestartTimer200ms;
Begin
  FormTime.Timer200ms.Enabled:=False;
  FormTime.Timer200ms.Interval:=200;
  Timeout200ms:=False;
  FormTime.Timer200ms.Enabled:=True
End;

Procedure RestartTimer500ms;
Begin
  FormTime.Timer500ms.Enabled:=False;
  FormTime.Timer500ms.Interval:=500;
  Timeout500ms:=False;
  FormTime.Timer500ms.Enabled:=True
End;

Procedure RestartTimer1000ms;
Begin
  FormTime.Timer1000ms.Enabled:=False;
  FormTime.Timer1000ms.Interval:=1000;
  Timeout1000ms:=False;
  FormTime.Timer1000ms.Enabled:=True
End;

Procedure RestartTimer2000ms;
Begin
  FormTime.Timer2000ms.Enabled:=False;
  FormTime.Timer2000ms.Interval:=2000;
  Timeout2000ms:=False;
  FormTime.Timer2000ms.Enabled:=True
End;

Procedure RestartTimer5000ms;
Begin
  FormTime.Timer5000ms.Enabled:=False;
  FormTime.Timer5000ms.Interval:=5000;
  Timeout5000ms:=False;
  FormTime.Timer5000ms.Enabled:=True
End;

Procedure RestartTimer16000ms;
Begin
  FormTime.Timer16000ms.Enabled:=False;
  FormTime.Timer16000ms.Interval:=16000;
  Timeout16000ms:=False;
  FormTime.Timer16000ms.Enabled:=True
End;

Procedure RestartTimer60000ms;
Begin
  FormTime.Timer60000ms.Enabled:=False;
  FormTime.Timer60000ms.Interval:=60000;
  Timeout60000ms:=False;
  FormTime.Timer60000ms.Enabled:=True
End;

procedure TFormTime.Timer50msTimer(Sender: TObject);
begin
  Timeout50ms:=True
end;

procedure TFormTime.Timer200msTimer(Sender: TObject);
begin
  Timeout200ms:=True
end;

procedure TFormTime.Timer500msTimer(Sender: TObject);
begin
  Timeout500ms:=True
end;

procedure TFormTime.Timer1000msTimer(Sender: TObject);
begin
  Timeout1000ms:=True
end;

procedure TFormTime.Timer2000msTimer(Sender: TObject);
begin
  Timeout2000ms:=True
end;

procedure TFormTime.Timer5000msTimer(Sender: TObject);
begin
  Timeout5000ms:=True
end;

procedure TFormTime.Timer16000msTimer(Sender: TObject);
begin
  Timeout16000ms:=True
end;

procedure TFormTime.Timer60000msTimer(Sender: TObject);
begin
  Timeout60000ms:=True
end;

end.
