unit Unitflwa;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Unitglob, Buttons, StdCtrls;

type
  TFormFirmwareWarning = class(TForm)
    Label1FlashWarning: TLabel;
    Label2FlashWarning: TLabel;
    BitBtnFirmwareRewriteNo: TBitBtn;
    BitBtnFirmwareRewriteYes: TBitBtn;
    procedure BitBtnFirmwareRewriteNoClick(Sender: TObject);
    procedure BitBtnFirmwareRewriteYesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormFirmwareWarning: TFormFirmwareWarning;

Procedure FlashWarning;

implementation

{$R *.DFM}

Procedure FlashWarning;
Begin
  FormFirmwareWarning.ModalResult:=MyResFirmWarnNone;
  FormFirmwareWarning.ShowModal
End;

procedure TFormFirmwareWarning.BitBtnFirmwareRewriteNoClick(
  Sender: TObject);
begin
  FormFirmwareWarning.ModalResult:=MyResFirmWarnBreak
end;

procedure TFormFirmwareWarning.BitBtnFirmwareRewriteYesClick(
  Sender: TObject);
begin
  FormFirmwareWarning.ModalResult:=MyResFirmWarnOkay
end;

procedure TFormFirmwareWarning.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  If (FormFirmwareWarning.ModalResult=MyResFirmWarnNone) Or
     (FormFirmwareWarning.ModalResult=mrCancel) Then
    Action:=caNone
end;

end.
